create domain jobid    varchar(16);
create domain queueid  varchar(16);
create domain timetype timestamp;

create table JobDesc (
       jobname      jobid,
       jobdesc      varchar,
       jobparams    varchar,
       jobhomedir   varchar,
       javaclass    varchar,
       hostname     varchar,
       port         smallint,
       restartcount smallint,
       restartdelay smallint, -- seconds
       schedpolicy  smallint, -- 0: trigger, 1: permanent, 2: calendar, 3: interval, 4: each-hour-of-day
       period       smallint, -- seconds
       daymask      smallint,
       hourmask     smallint
);

create table QueueDesc (
       qname        queueid,
       ovfhnd       jobid,   -- handler of queue overflow
       maxelems     smallint -- maximal size of elements in queue
);

create table JobCalendar (
       jobname      jobid,
       nextrun      timetype
);

create table JobFlow (
       srcjob       jobid,
       dstjob       jobid,
       iffails      tinyint -- 0: if-succeede, 1: if-fails
);

-- tables below are filled by scheduler

create table JobState (
       jobname      jobid,
       status       tinyint, -- 0: ready, 1: succeed, 2: failed, 3: running
       started      timetype,
       finished     timetype
);
  
create index jobIdx on JobState(jobname);

create table QueueState (
       qname        queueid,
       pending      smallint  -- number of pended requests
);

create index queueIdx on QueueState(qname);
