package org.garret.scheduler;

import java.io.*;
import java.util.Date;

public class ExecuteProcess { 
    static class PipeReader implements Runnable { 
        InputStream pipe;
        Job         job;
        
        public void run() {
            byte buf[] = new byte[1024];
            int rc;
            
            try { 
                while ((rc = pipe.read(buf)) > 0) { 
                    job.trace.write(buf, 0, rc);
                }
            } catch (IOException x) {}
        }
        PipeReader(Job job, InputStream pipe) { 
            this.job = job;
            this.pipe = pipe;
        }
    }


    public static int run(Job job) throws Exception
    {
        File homeDir = job.homeDir.length() == 0 ? null : new File(job.homeDir);
        Process proc = Runtime.getRuntime().exec(job.params, null, homeDir);
        PipeReader stdoutReader = new PipeReader(job, proc.getInputStream());
        PipeReader stderrReader = new PipeReader(job, proc.getErrorStream());
        ThreadPool.getInstance().start(stderrReader);
        stdoutReader.run();
        return proc.waitFor();
    }
    
}


